<?php
/**
*
* @package ucp
* @version $Id: ucp_alerts.php battye $
* @copyright (c) 2009 battye (CricketMX.com)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_alerts
* @package ucp
*/
class ucp_alerts
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;

		$submit	= ( isset($_POST['add']) ) ? true : false;
		$delete	= ( request_var('delete', 0) > 0 ) ? true : false;
		$s_hidden_fields = '';
		
		if($delete) // delete an event
		{
			if (confirm_box(true))
			{
				$sql = "DELETE FROM " . ALERTS_TABLE . "
						WHERE alert_id = " . request_var('delete', 0) . "
						AND user_id = " . $user->data['user_id'];
				$db->sql_query($sql);

				trigger_error( sprintf($user->lang['UCP_ALERTS_DELETE_SUCCESS'], "<a href='" . append_sid($this->u_action) . "'>", "</a>") );
			}

			confirm_box(false, 'UCP_ALERTS_DELETE');
		}

		else if($submit) // Submit the alert to the database
		{
			$alert_name = utf8_normalize_nfc(request_var('add', '', true));

			$s_month 	= request_var('smonth', 0);
			$s_day 		= request_var('sday', 0);
			$s_year 	= request_var('syear', 0);

			$box_day	= request_var('day', 0);			// get an alert ON the day
			$box_day_b	= request_var('daybefore', 0);		// alert the day before
			$box_week	= request_var('week', 0);			// alert 7 days before
			$box_week_l	= request_var('week_leading', 0);	// alert 7 days before
		
			$s_check	= !$s_month || !$s_day || !$s_year;
			$box_check	= !$box_day && !$box_day_b && !$box_week && !$box_week_l;

			if( $s_check || $box_check || strlen($alert_name) == 0 )
			{
				trigger_error( sprintf($user->lang['UCP_ALERTS_FORM_REDO'], "<a href='" . append_sid($this->u_action) . "'>", "</a>") );
			}
	
				// Get the right time and date organised
 				$time_now 	= getdate(mktime(0, 0, 0, $s_month, $s_day, $s_year) + $user->timezone + $user->dst - date('Z'));
   				$alert_time	= mktime(0, 0, 0, $time_now['mon'], $time_now['mday'], $time_now['year'], date('I'));

				$alert_on_day 			= ($box_day) 	? $user->lang['UCP_ALERTS_DAY'] . '<br />'			: '';
				$alert_on_day_before 	= ($box_day_b) 	? $user->lang['UCP_ALERTS_DAY_BEFORE'] . '<br />' 	: '';
				$alert_week_before 		= ($box_week) 	? $user->lang['UCP_ALERTS_WEEK_BEFORE'] . '<br />' 	: '';
				$alert_week_leading		= ($box_week_l) ? $user->lang['UCP_ALERTS_WEEK_LEADING'] . '<br />' : '';

				// Global alerts only apply to admins
				// a global alert is one that all users can see
				$alert_global = 0;
				if( $auth->acl_get('a_') )
				{
					$alert_global = request_var('alert_global', 0);
				}

				$insert_data = array(
 					'user_id'				=> $user->data['user_id'],
  					'alert_text'			=> $alert_name,
 					'alert_time'			=> $alert_time,
  					'alert_day'				=> $box_day,
 					'alert_day_before'		=> $box_day_b,
 					'alert_week'			=> $box_week,
 					'alert_week_leading'	=> $box_week_l,
					'alert_global'			=> $alert_global,
				);

			$sql = 'INSERT INTO ' . ALERTS_TABLE . ' ' . $db->sql_build_array('INSERT', $insert_data);
			$db->sql_query($sql);

			trigger_error(sprintf($user->lang['UCP_ALERTS_SUBMITTED'], $user->format_date($alert_time), $alert_on_day . $alert_on_day_before . $alert_week_before . $alert_week_leading, "<a href='" . append_sid($this->u_action) . "'>", "</a>"));
		}

		else
		{
			$sql = 'SELECT * FROM ' . ALERTS_TABLE . '
					WHERE user_id = ' . $user->data['user_id'] . '
					ORDER BY alert_time ASC';
			$result = $db->sql_query($sql);
			while( $row = $db->sql_fetchrow($result) )
			{
				// How many days before the alert wil lthe user be notified
				$notify  = ($row['alert_day']) 			? $user->lang['UCP_ALERTS_DAY'] . '<br />' 			: '';
				$notify .= ($row['alert_day_before']) 	? $user->lang['UCP_ALERTS_DAY_BEFORE'] . '<br />' 	: '';
				$notify .= ($row['alert_week']) 		? $user->lang['UCP_ALERTS_WEEK_BEFORE'] . '<br />' 	: '';
				$notify .= ($row['alert_week_leading']) ? $user->lang['UCP_ALERTS_WEEK_LEADING'] . '<br />'	: '';
				$notify .= ($row['alert_global']) 		? $user->lang['UCP_ALERTS_GLOBAL'] . '<br />'	: '';
	
				$template->assign_block_vars('alerts', array(
				'U_ALERT'			=> $row['alert_text'],	
				'U_DATE'			=> $user->format_date($row['alert_time']),
				'U_NOTIFY'			=> $notify,
				'U_DELETE'			=> $user->img('icon_post_delete', 'DELETE_POST'),
				'U_DELETE_LINK'		=> append_sid($this->u_action, "delete=" . $row['alert_id']),
				));
			}
			$db->sql_freeresult($result);
	
			// Inspired from the dropdowns in the ucp_profile page
			$s_day_options = '<option value="0">--</option>';
			for( $i = 1; $i <= 31; $i++ ) // days
			{
				$s_day_options .= '<option value="' . $i . '">' . $i . '</option>';
			}
	
			$s_month_options = '<option value="0">--</option>';
			for( $i = 1; $i <= 12; $i++ ) // month
			{
				$s_month_options .= '<option value="' . $i . '">' . $i . '</option>';
			}
	
			$s_year_options = '<option value="0">--</option>';
			for( $i = 2010; $i <= 2020; $i++ ) // year - we will go 10 years in advance
			{
				$s_year_options .= '<option value="' . $i . '">' . $i . '</option>';
			}
	
			$template->assign_vars(array( 
			'S_UCP_ACTION'		=> append_sid($this->u_action),
	
			'S_DAY'				=> $s_day_options,	
			'S_MONTH'			=> $s_month_options,	
			'S_YEAR'			=> $s_year_options,	

			'U_ALERT_GLOBAL'	=> $auth->acl_get('a_'),
			));
	
	
			$this->tpl_name = 'ucp_alerts';
			$this->page_title = 'UCP_ALERTS';
		}
	}
}

?>